#include <fxlib.h>
#include <timer.h>
#include "MonochromeLib.h"

#include "basic_var.h"
#include "key.h"
#include "syscall.h"
#include "timer.h"

void timer_start()
{
	// SetQuitHandler(timer_stop);
	SetTimer(ID_USER_TIMER1, TIMER_DELAY, timer);
}

void timer_stop()
{
	int key=0;
	KillTimer(ID_USER_TIMER1);
	PopUpWin(4);
	locate(3, 3);
	Print("PRGM2's timer");
	locate(3, 4);
	Print("has been stopped.");
	Bdisp_PutDisp_DD();
	// Sleep(500);
}

/************************************************/

enum {
	VOID,
	ClearVRAM, ClearScreen, DisplayVRAM,
	SetContrast, GetContrast,
	SetPixel, GetPixel, DrawLine, DrawRectangle, DrawCircle, DrawFilledCircle,
	SerialOpen, SerialClose, SerialRead, SerialWrite,
	KeyDown
} Functions;

void timer()
{
	int function;
	unsigned char byte=0;
	if(IsKeyDown(KEY_CTRL_MENU)) {
		timer_stop();
		return;
	}
	function = var_toint('F');
	if(!function) return;
	switch(function) {
		case ClearVRAM: ML_clear_vram(); break;
		case ClearScreen: ML_clear_screen(); break;
		case DisplayVRAM: ML_display_vram(); break;
		case SetContrast: ML_set_contrast(var_toint('C')); break;
		case GetContrast: var_setvarint('R', ML_get_contrast()); break;
		case SetPixel: ML_pixel(var_toint('X'), var_toint('Y'), var_toint('C')); break;
		case GetPixel: var_setvarint('R', ML_pixel_test(var_toint('X'), var_toint('Y'))); break;
		case DrawLine: ML_line(var_toint('X'), var_toint('Y'), var_imaginarypart_toint('X'), var_imaginarypart_toint('Y'), var_toint('C')); break;
		case DrawRectangle: ML_rectangle(var_toint('X'), var_toint('Y'), var_imaginarypart_toint('X'), var_imaginarypart_toint('Y'), 0, 0, var_toint('C')); break;
		case DrawCircle: ML_circle(var_toint('X'), var_toint('Y'), var_toint('R'), var_toint('C')); break;
		case DrawFilledCircle: ML_filled_circle(var_toint('X'), var_toint('Y'), var_toint('R'), var_toint('C')); break;
		case SerialOpen: { char conf[] = {0, 9, 0, 0, 0, 0}; var_setvarint('R', Serial_Open(conf)); } break;
		case SerialClose: while(Serial_Close(0) == 5); break;
		case SerialRead: var_setvarint('R', Serial_ReadByte(&byte)); var_setvarint('B', byte); break;
		case SerialWrite: Serial_WriteByte(var_toint('B')); break;
		case KeyDown: var_setvarint('R', keydown((var_toint('K')))); break;
	}
	var_reset('F');
}
